Public Member Functions | Static Public Member Functions | Static Protected Member Functions | Private Types | Private Member Functions | Static Private Member Functions | Private Attributes

# Squirrel Class Reference

## Public Member Functions
| Squirrel (const char *APIName)
HSQUIRRELVM | GetVM ()
| Get the squirrel VM.
bool | LoadScript (const char *script)
| Load a script.
bool | LoadScript (HSQUIRRELVM vm, const char *script, bool in_root=true)
SQRESULT | LoadFile (HSQUIRRELVM vm, const char *filename, SQBool printerror)
| Load a file to a given VM.
void | AddMethod (const char *method_name, SQFUNCTION proc, uint nparam=0, const char *params=NULL, void *userdata=NULL, int size=0)
| Adds a function to the stack.
void | AddConst (const char *var_name, int value)
| Adds a const to the stack.
void | AddConst (const char *var_name, uint value)
| Adds a const to the stack.
void | AddConst (const char *var_name, bool value)
| Adds a const to the stack.
void | AddClassBegin (const char *class_name)
| Adds a class to the global scope.
void | AddClassBegin (const char *class_name, const char *parent_class)
| Adds a class to the global scope, extending 'parent_class'.
void | AddClassEnd ()
| Finishes adding a class to the global scope.
bool | Resume (int suspend=-1)
| Resume a VM when it was suspended via a throw.
void | ResumeError ()
| Resume the VM with an error so it prints a stack trace.
void | CollectGarbage ()
| Tell the VM to do a garbage collection run.
void | InsertResult (bool result)
void | InsertResult (int result)
void | InsertResult (uint result)
bool | CallMethod (HSQOBJECT instance, const char *method_name, HSQOBJECT *ret, int suspend)
| Call a method of an instance, in various flavors.
bool | CallMethod (HSQOBJECT instance, const char *method_name, int suspend)
bool | CallStringMethodStrdup (HSQOBJECT instance, const char *method_name, const char **res, int suspend)
bool | CallIntegerMethod (HSQOBJECT instance, const char *method_name, int *res, int suspend)
bool | CallBoolMethod (HSQOBJECT instance, const char *method_name, bool *res, int suspend)
bool | MethodExists (HSQOBJECT instance, const char *method_name)
| Check if a method exists in an instance.
bool | CreateClassInstance (const char *class_name, void *real_instance, HSQOBJECT *instance)
| Exactly the same as CreateClassInstanceVM, only callable without instance of Squirrel.
void | SetGlobalPointer (void *ptr)
| Sets a pointer in the VM that is reachable from where ever you are in SQ.
void | SetPrintFunction (SQPrintFunc *func)
| Set a custom print function, so you can handle outputs from SQ yourself.
void | ThrowError (const char *error)
| Throw a Squirrel error that will be nicely displayed to the user.
void | ReleaseObject (HSQOBJECT *ptr)
| Release a SQ object.
bool | IsSuspended ()
| Did the squirrel code suspend or return normally.
bool | HasScriptCrashed ()
| Find out if the squirrel script made an error before.
void | ResetCrashed ()
| Reset the crashed status.
void | CrashOccurred ()
| Set the script status to crashed.
bool | CanSuspend ()
| Are we allowed to suspend the squirrel script at this moment?
SQInteger | GetOpsTillSuspend ()
| How many operations can we execute till suspension?
## Static Public Member Functions
static bool | CreateClassInstanceVM (HSQUIRRELVM vm, const char *class_name, void *real_instance, HSQOBJECT *instance, SQRELEASEHOOK release_hook, bool prepend_API_name=false)
| Creates a class instance.
static bool | GetRealInstance (HSQUIRRELVM vm, SQUserPointer *ptr)
| Get the real-instance pointer.
static bool | GetInstance (HSQUIRRELVM vm, HSQOBJECT *ptr, int pos=1)
| Get the Squirrel-instance pointer.
static const char * | ObjectToString (HSQOBJECT *ptr)
| Convert a Squirrel-object to a string.
static int | ObjectToInteger (HSQOBJECT *ptr)
| Convert a Squirrel-object to an integer.
static bool | ObjectToBool (HSQOBJECT *ptr)
| Convert a Squirrel-object to a bool.
static void * | GetGlobalPointer (HSQUIRRELVM vm)
| Get the pointer as set by SetGlobalPointer.
static void | DecreaseOps (HSQUIRRELVM vm, int amount)
| Tell the VM to remove `amount` ops from the number of ops till suspend.
## Static Protected Member Functions
static void | CompileError (HSQUIRRELVM vm, const SQChar *desc, const SQChar *source, SQInteger line, SQInteger column)
| The CompileError handler.
static void | RunError (HSQUIRRELVM vm, const SQChar *error)
| The RunError handler.
static void | PrintFunc (HSQUIRRELVM vm, const SQChar *s,...)
| If a user runs 'print' inside a script, this function gets the params.
static void | ErrorPrintFunc (HSQUIRRELVM vm, const SQChar *s,...)
| If an error has to be print, this function is called.
## Private Types
typedef void( | SQPrintFunc )(bool error_msg, const SQChar *message)
## Private Member Functions
const char * | GetAPIName ()
| Get the API name.
## Static Private Member Functions
static SQInteger | _RunError (HSQUIRRELVM vm)
| The internal RunError handler.
## Private Attributes
HSQUIRRELVM | vm
| The VirtualMachine instance for squirrel.
void * | global_pointer
| Can be set by who ever initializes Squirrel.
SQPrintFunc * | print_func
| Points to either NULL, or a custom print handler.
bool | crashed
| True if the squirrel script made an error.
int | overdrawn_ops
| The amount of operations we have overdrawn.
const char * | APIName
| Name of the API used for this squirrel.

## Detailed Description

Definition at line 23 of file squirrel.hpp.

## Member Function Documentation

SQInteger Squirrel::_RunError | ( | HSQUIRRELVM | vm | ) | `[static, private]`

The internal RunError handler.

It looks up the real error and calls RunError with it.

Definition at line 84 of file squirrel.cpp.

References RunError().

void Squirrel::AddClassBegin | ( | const char * | class_name,
|  | const char * | parent_class |
| ) |  |  |

Adds a class to the global scope, extending 'parent_class'.

Make sure to call AddClassEnd when you are done adding methods.

Definition at line 154 of file squirrel.cpp.

References DEBUG, and vm.

void Squirrel::AddClassBegin | ( | const char * | class_name | ) |

Adds a class to the global scope.

Make sure to call AddClassEnd when you are done adding methods.

Definition at line 147 of file squirrel.cpp.

References vm.

Referenced by GameLibrary::RegisterAPI(), and AILibrary::RegisterAPI().

void Squirrel::AddClassEnd | ( |  | ) |

Finishes adding a class to the global scope.

If this isn't called, no class is really created.

Definition at line 167 of file squirrel.cpp.

References vm.

Referenced by GameLibrary::RegisterAPI(), and AILibrary::RegisterAPI().

void Squirrel::AddConst | ( | const char * | var_name,
|  | uint | value |
| ) |  |  | `[inline]`

Adds a const to the stack.

Depending on the current state this means either a const to a class or to the global space.

Definition at line 103 of file squirrel.hpp.

References AddConst().

Referenced by AddConst().

void Squirrel::AddConst | ( | const char * | var_name,
|  | int | value |
| ) |  |  |

Adds a const to the stack.

Depending on the current state this means either a const to a class or to the global space.

Definition at line 133 of file squirrel.cpp.

References vm.

void Squirrel::AddConst | ( | const char * | var_name,
|  | bool | value |
| ) |  |  |

Adds a const to the stack.

Depending on the current state this means either a const to a class or to the global space.

Definition at line 140 of file squirrel.cpp.

References vm.

void Squirrel::AddMethod | ( | const char * | method_name,
|  | SQFUNCTION | proc,
|  | uint | nparam = `0`,
|  | const char * | params = `NULL`,
|  | void * | userdata = `NULL`,
|  | int | size = `0` |
| ) |  |  |

Adds a function to the stack.

Depending on the current state this means either a method or a global function.

Definition at line 118 of file squirrel.cpp.

References vm.

Referenced by DefSQClass< CL, ST >::DefSQAdvancedMethod(), DefSQClass< CL, ST >::DefSQAdvancedStaticMethod(), DefSQClass< CL, ST >::DefSQMethod(), DefSQClass< CL, ST >::DefSQStaticMethod(), GameLibrary::RegisterAPI(), GameInfo::RegisterAPI(), AILibrary::RegisterAPI(), AIInfo::RegisterAPI(), squirrel_register_global_std(), and squirrel_register_std().

bool Squirrel::CallMethod | ( | HSQOBJECT | instance,
|  | const char * | method_name,
|  | HSQOBJECT * | ret,
|  | int | suspend |
| ) |  |  |

Call a method of an instance, in various flavors.

Returns:
  False if the script crashed or returned a wrong type.

Definition at line 219 of file squirrel.cpp.

References crashed, DEBUG, IsSuspended(), and vm.

Referenced by ScriptInstance::GameLoop(), ScriptInfo::GetSettings(), and ScriptInstance::Save().

bool Squirrel::CreateClassInstanceVM | ( | HSQUIRRELVM | vm,
|  | const char * | class_name,
|  | void * | real_instance,
|  | HSQOBJECT * | instance,
|  | SQRELEASEHOOK | release_hook,
|  | bool | prepend_API_name = `false` |
| ) |  |  | `[static]`

Creates a class instance.

Parameters:

  | vm | The VM to create the class instance for
  | class_name | The name of the class of which we create an instance.
  | real_instance | The instance to the real class, if it represents a real class.
  | instance | Returning value with the pointer to the instance.
  | release_hook | Optional param to give a release hook.
  | prepend_API_name | Optional parameter; if true, the class_name is prefixed with the current API name.

Returns:
  False if creating failed.

Definition at line 278 of file squirrel.cpp.

References DEBUG, and GetAPIName().

Referenced by CreateClassInstance().

static bool Squirrel::GetInstance | ( | HSQUIRRELVM | vm,
|  | HSQOBJECT * | ptr,
|  | int | pos = `1` |
| ) |  |  | `[inline, static]`

Get the Squirrel-instance pointer.

Note:
  This will only work just after a function-call from within Squirrel to your C++ function.

Definition at line 192 of file squirrel.hpp.

Referenced by ScriptInfo::Constructor(), SQConvert::DefSQAdvancedNonStaticCallback(), and SQConvert::DefSQNonStaticCallback().

static bool Squirrel::GetRealInstance | ( | HSQUIRRELVM | vm,
|  | SQUserPointer * | ptr |
| ) |  |  | `[inline, static]`

Get the real-instance pointer.

Note:
  This will only work just after a function-call from within Squirrel to your C++ function.

Definition at line 185 of file squirrel.hpp.

HSQUIRRELVM Squirrel::GetVM | ( |  | ) | `[inline]`

Get the squirrel VM.

Try to avoid using this.

Definition at line 72 of file squirrel.hpp.

References vm.

Referenced by ScriptInstance::CallLoad(), ScriptInstance::GameLoop(), ScriptInstance::Load(), AIInstance::LoadDummyScript(), ScriptInstance::Pause(), RegisterGameTranslation(), ScriptInstance::Save(), and squirrel_register_std().

bool Squirrel::IsSuspended | ( |  | ) |

Did the squirrel code suspend or return normally.

Returns:
  True if the function suspended.

Definition at line 575 of file squirrel.cpp.

Referenced by CallMethod(), ScriptInstance::GameLoop(), ScriptInstance::Initialize(), and ScriptInstance::Save().

bool Squirrel::LoadScript | ( | const char * | script | ) |

Load a script.

Parameters:

  | script | The full script-name to load.

Returns:
  False if loading failed.

Definition at line 540 of file squirrel.cpp.

Referenced by ScriptScanner::AddFile(), ScriptInstance::Initialize(), ScriptInstance::LoadCompatibilityScripts(), and SquirrelStd::require().

void Squirrel::SetGlobalPointer | ( | void * | ptr | ) | `[inline]`

Sets a pointer in the VM that is reachable from where ever you are in SQ.

Useful to keep track of the main instance.

Definition at line 213 of file squirrel.hpp.

References global_pointer.

Referenced by ScriptScanner::Initialize(), and ScriptInstance::Initialize().

The documentation for this class was generated from the following files:

- src/script/squirrel.hpp
- src/script/squirrel.cpp